Attribute VB_Name = "intersection"
'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type
'---------------------------------------------------------------------------
' Triangle en 3D
'---------------------------------------------------------------------------
Public Type Triangle3
   S(2) As Point3
End Type
    


'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function

'----------------------------------------------------------------------------
Sub ProjectionTriangle(rkD As Point3, akV As Triangle3, rfMin As Double, rfMax As Double)
Dim afDot(2) As Double


    afDot(0) = Dot(rkD, akV.S(0))
    afDot(1) = Dot(rkD, akV.S(1))
    afDot(2) = Dot(rkD, akV.S(2))


    rfMin = afDot(0)
    rfMax = rfMin

    If (afDot(1) < rfMin) Then
        rfMin = afDot(1)
    Else
        If (afDot(1) > rfMax) Then
            rfMax = afDot(1)
        End If
    End If

    If (afDot(2) < rfMin) Then
        rfMin = afDot(2)
    Else
        If (afDot(2) > rfMax) Then
            rfMax = afDot(2)
        End If
    End If

End Sub
'----------------------------------------------------------------------------
Function TestIntersectionTriangle(akU As Triangle3, akV As Triangle3) As Boolean
    Dim kDir As Point3
    Dim fUMin As Double
    Dim fUMax As Double
    Dim fVMin As Double
    Dim fVMax As Double
    Dim fMdV0 As Double
    Dim i0, i1 As Integer
    Dim akE As Triangle3
    Dim akF As Triangle3
    
    Dim kN As Point3
    Dim kM As Point3
    Dim kNxM As Point3
    
    Dim fNdU0 As Double
    Const fEpsilon As Double = 0.000001 ' sin(Angle(N,M)) < epsilon
   

       
    ' direction N
    akE.S(0) = VecSub(akU.S(1), akU.S(0))
    akE.S(1) = VecSub(akU.S(2), akU.S(1))
    akE.S(2) = VecSub(akU.S(0), akU.S(2))


    ' Normal du triangle 1
    kN = VecProd(akE.S(0), akE.S(1))
    
    fNdU0 = Dot(kN, akU.S(0))
    Call ProjectionTriangle(kN, akV, fVMin, fVMax)
    If fNdU0 < fVMin Or fNdU0 > fVMax Then
        TestIntersectionTriangle = False
        Exit Function
    End If
    
    ' direction M
    akF.S(0) = VecSub(akV.S(1), akV.S(0))
    akF.S(1) = VecSub(akV.S(2), akV.S(1))
    akF.S(2) = VecSub(akV.S(0), akV.S(2))
    
    
    ' Normal du triangle 1
    kM = VecProd(akF.S(0), akF.S(1))
    
     ' Normal issu de normal Triangle 1 et normal triangle 2
    kNxM = VecProd(kN, kM)
    

    If Dot(kNxM, kNxM) >= (fEpsilon * Dot(kN, kN) * Dot(kM, kM)) Then
        ' les triangles ne sont paralleles
        fMdV0 = Dot(kM, akV.S(0))
        
        Call ProjectionTriangle(kM, akU, fUMin, fUMax)
        If (fMdV0 < fUMin Or fMdV0 > fUMax) Then
                TestIntersectionTriangle = False
                Exit Function
        End If

        ' directions E(i0)xF(i1)
        For i1 = 0 To 2
            For i0 = 0 To 2
                kDir = VecProd(akE.S(i0), akF.S(i1))
                Call ProjectionTriangle(kDir, akU, fUMin, fUMax)
                Call ProjectionTriangle(kDir, akV, fVMin, fVMax)
                If (fUMax < fVMin Or fVMax < fUMin) Then
                    TestIntersectionTriangle = False
                    Exit Function
                End If
            Next i0
        Next i1
    Else  ' triangles sont paralleles (et, coplanair)
        ' directions NxE(i0)
        For i0 = 0 To 2
            kDir = VecProd(kN, akE.S(i0))
            Call ProjectionTriangle(kDir, akU, fUMin, fUMax)
            Call ProjectionTriangle(kDir, akV, fVMin, fVMax)
            If (fUMax < fVMin Or fVMax < fUMin) Then
                TestIntersectionTriangle = False
                Exit Function
            End If
        Next i0

        ' directions NxF(i1)
        For i1 = 0 To 2
            kDir = VecProd(kM, akF.S(i1))
            Call ProjectionTriangle(kDir, akU, fUMin, fUMax)
            Call ProjectionTriangle(kDir, akV, fVMin, fVMax)
            If (fUMax < fVMin Or fVMax < fUMin) Then
                TestIntersectionTriangle = False
                Exit Function
            End If
        Next i1
        
    End If

    TestIntersectionTriangle = True
End Function
'----------------------------------------------------------------------------
